"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _htmlWebpackPlugin = _interopRequireDefault(require("html-webpack-plugin"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

class HtmlWebpackInjectPlugin {
  constructor(config) {
    _defineProperty(this, "assets", void 0);

    _defineProperty(this, "parent", void 0);

    _defineProperty(this, "prepend", void 0);

    _defineProperty(this, "apply", compiler => {
      compiler.hooks.compilation.tap('HtmlWebpackInjectPlugin', compilation => {
        const hooks = _htmlWebpackPlugin.default.getHooks(compilation).alterAssetTagGroups;

        hooks.tapAsync('HtmlWebpackInjectPlugin', (htmlPluginData, cb) => {
          const propertyName = `${this.parent}Tags`;
          const tags = htmlPluginData[propertyName];
          htmlPluginData[propertyName] = this.prepend ? this.assets.concat(tags) : tags.concat(this.assets);
          return cb(null, htmlPluginData);
        });
      });
    });

    const {
      externals = [],
      parent = 'head',
      prepend = false
    } = config;
    this.assets = externals.map(({
      tag = 'meta',
      attrs = {},
      innerHTML,
      voidTag
    }) => {
      return {
        tagName: tag,
        attributes: attrs,
        innerHTML,
        voidTag,
        meta: {
          plugin: 'HtmlWebpackInjectPlugin'
        }
      };
    });

    if (parent !== 'head' && parent !== 'body') {
      throw new TypeError('parent should be one of `head` or `body`');
    }

    this.parent = parent;
    this.prepend = prepend;
  }

}

exports.default = HtmlWebpackInjectPlugin;